<?php

function station_set_wifiConfig()
{
    $desc = "system failed";
    $server_domain = "/www/v1.0/srv_domain_file.unix";
    $ret = 0;
    

    $ssid = $_POST["ssid"];
    $key = $_POST["key"];

    /*
    var_dump(mb_detect_encoding($ssid, ['ASCII', 'UTF-8'], true));
    var_dump(mb_detect_encoding($key, ['ASCII'], true));
    */
    

    if($ssid == NULL || $key == NULL){
        $ret = 1006;
        $desc = "Params is null.";
        goto __failed;  
    }

    $param_len = strlen($ssid);

    if($param_len < 1 || $param_len > 32){
        $ret = 1003;
        $desc = "SSID too long";
        goto __failed;  
    }

    $param_len = strlen($key);

    if($param_len < 8){
        $ret = 1003;
        $desc = "KEY is too short";
        goto __failed;  
    }else if($param_len > 63){
        $ret = 1003;
        $desc = "KEY is too long";
        goto __failed;  
    }

    $encode=mb_detect_encoding($key, ['ASCII'], true);

    if($encode != 'ASCII'){
        $ret = 1002;
        $desc = "KEY isn't ASCII";
        goto __failed; 
    }

    if (!($socket = socket_create(AF_UNIX, SOCK_STREAM, 0))){
        $ret = 1004;
        $desc = "socket_create error";
        goto __failed;
    }

    if((socket_connect($socket, $server_domain)) == FALSE){
        $ret = 1005;
        $desc = "socket_connect error";
        goto __close_sock;
    }

    $msg = "{\"cmd\":16,\"ssid\":\"$ssid\",\"key\":\"$key\"}";
    $len = strlen($msg);
    $bytes_sent = socket_send($socket, $msg, $len, MSG_DONTROUTE);

    if ($bytes_sent == FALSE){
        $ret = 1007;
        $desc = "socket_send error";
        goto __close_sock;
    }else if ($bytes_sent != $len){
        $ret = 1008;
        $desc = "socket_send error";
        goto __close_sock;
    }
    $time = 0;
    while(1){
        if($time > 200){
            $ret = 1009;
            $desc = "Timeout error";
            goto __close_sock;
        }
        
        if (FALSE !== ($bytes=socket_recv($socket,$buf,1024,MSG_DONTWAIT))) {
            //echo "Read $bytes bytes from socket_read(): $buf <br>";

            $obj = json_decode($buf);

            if(NULL == $obj){
                $ret = 1010;
                $desc = "json_decode error";
                goto __close_sock;
            }

            if($obj->{'result'} == 0){
                echo "{\"status\":\"0\",\"error\":\"0\",\"desc\":\"ok\"}";
            }else{
                $ret = 1011;
                $desc = "System Result:" . $obj->{'result'};
                goto __close_sock;
            }
        
            break;
        } 

        usleep(100000);
        $time++;
    }


    
    socket_close($socket);

    return;


__close_sock:
    socket_close($socket);
 __failed:  
    http_response_code(500);
    echo "{\"status\":\"1\",\"error\":\"$ret\",\"desc\":\"$desc\"}"; 
}  


?>